#!/usr/bin/env python
# coding: utf-8

# In[1]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import json
import itkdb
import time

def flex_panel_registration_interface():
    #global variables from function access

    #global variables from function access
    db_password1 = None
    db_password2 = None
    client = None

    
    app = tk.Toplevel()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Hybrid Flex Panel Registration', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    #####Password verification
    
    
    label_pw = tk.Label(app, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=40, justify='left', bg='yellow') 
    label_pw.pack(padx = 10, pady = 10)
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(row=1, column=1)
    entry_pw1 = tk.Entry(frame_pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(row=1, column=2)


    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(row=2, column=1)
    entry_pw2 = tk.Entry(frame_pw1)
    entry_pw2['show'] = '*'
    entry_pw2.grid(row=2, column=2)




    def pw_read():
        global db_password1, db_password2, client
        db_password1 = entry_pw1.get()
        db_password2 = entry_pw2.get()
        if db_password1 and db_password2 :
            box.showinfo( 'Confirmation', 'Received Passwords' )
            try:
                u = itkdb.core.User(accessCode1=db_password1, accessCode2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                box.showinfo( 'Success', 'Hello {} {}, \nwelcome to the ITk database'                             .format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                entry_pw1.delete(0,'end')
                entry_pw2.delete(0,'end')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 


    button = tk.Button(app, text='Get Password', width=25, command = pw_read, bg='yellow' )
    button.pack(padx = 10, pady = 10)
    
    
    
    label_subsection = tk.Label(app, text='Hybrid Array Creation', bg='deepskyblue', fg='black', font=('Arial Black', 10))
    label_subsection.pack(padx = 10, pady = 10)
    
    
    
    
    
    #Panel name
    frame_sn = tk.Frame(app)
    frame_sn.pack(padx = 10, pady = 10)
    label_sn_name = tk.Label(frame_sn, text='Alternative ID of panel: ')
    label_sn_name.grid(row=1, column=1)
    panel_name_entry = tk.Entry(frame_sn, width = 35)
    panel_name_entry.grid(row=1, column=2)
    label_sn_example = tk.Label(frame_sn, text='Format: <Batch>_<type>_<number>')
    label_sn_example.grid(sticky="w", row=2, column=2)
    label_sn_example2 = tk.Label(frame_sn, text='e.g.: GPC1919_X_003')
    label_sn_example2.grid(sticky="w", row=3, column=2)
    
    
    
    frame_imp = tk.Frame(app)
    frame_imp.pack(padx = 10, pady = 10)
    label_imp_name = tk.Label(frame_imp, text='Impedance of Panel: ')
    label_imp_name.grid(row=1, column=1)
    panel_imp_entry = tk.Entry(frame_imp, width = 35)
    panel_imp_entry.grid(row=1, column=2)
    label_imp_example = tk.Label(frame_imp, text='Alternative: enter average Impedance of batch')
    label_imp_example.grid(sticky="w", row=2, column=2)
 

    
    
    #Arrays for deletion
    array_frame = tk.Frame(app)
    array_frame.pack( padx=10, pady=10 )
    label_array_info = tk.Label(array_frame, text='Which arrays were not delivered?')
    label_array_info.grid(row=1, columnspan=4)

    label_array = tk.Label(array_frame, text='Array: ')
    label_array.grid(row=2, column=0)
    
    array_A = tk.BooleanVar()
    array_A_button = tk.Checkbutton( array_frame, text="A", variable=array_A, onvalue=True, offvalue=False )
    array_A_button.grid(row=2, column=1, padx=8)
    
    array_B = tk.BooleanVar()
    array_B_button = tk.Checkbutton( array_frame, text="B", variable=array_B, onvalue=True, offvalue=False )
    array_B_button.grid(row=2, column=2, padx=8)
    
    array_C = tk.BooleanVar()
    array_C_button = tk.Checkbutton( array_frame, text="C", variable=array_C, onvalue=True, offvalue=False )
    array_C_button.grid(row=2, column=3, padx=8)
    

    #Hybrid/Test-Coupon Cross outs
    hybrid_frame = tk.Frame(app)
    hybrid_frame.pack( padx=10, pady=10 )
    label_hybrid_info = tk.Label(hybrid_frame, text='Which hybrids/test-coupons are cross-outs?')
    label_hybrid_info.grid(row=0, columnspan=10)

    labelA = tk.Label(hybrid_frame, text='Array A: ', width = 8)
    labelA.grid(row=1, column=0)
    
    hybrid_A_0 = tk.BooleanVar()
    hybrid_A_0_button = tk.Checkbutton( hybrid_frame, text="H0", variable=hybrid_A_0, onvalue=True, offvalue=False )
    hybrid_A_0_button.grid(row=1, column=2, padx=8)
    
    hybrid_A_1 = tk.BooleanVar()
    hybrid_A_1_button = tk.Checkbutton( hybrid_frame, text="H1", variable=hybrid_A_1, onvalue=True, offvalue=False )
    hybrid_A_1_button.grid(row=1, column=3, padx=8)
    
    hybrid_A_2 = tk.BooleanVar()
    hybrid_A_2_button = tk.Checkbutton( hybrid_frame, text="H2", variable=hybrid_A_2, onvalue=True, offvalue=False )
    hybrid_A_2_button.grid(row=1, column=4, padx=8)
    
    hybrid_A_3 = tk.BooleanVar()
    hybrid_A_3_button = tk.Checkbutton( hybrid_frame, text="H3", variable=hybrid_A_3, onvalue=True, offvalue=False )
    hybrid_A_3_button.grid(row=1, column=5, padx=8)
    
    hybrid_A_4 = tk.BooleanVar()
    hybrid_A_4_button = tk.Checkbutton( hybrid_frame, text="H4", variable=hybrid_A_4, onvalue=True, offvalue=False )
    hybrid_A_4_button.grid(row=1, column=6, padx=8)
    
    hybrid_A_5 = tk.BooleanVar()
    hybrid_A_5_button = tk.Checkbutton( hybrid_frame, text="H5", variable=hybrid_A_5, onvalue=True, offvalue=False )
    hybrid_A_5_button.grid(row=1, column=7, padx=8)
    
    hybrid_A_6 = tk.BooleanVar()
    hybrid_A_6_button = tk.Checkbutton( hybrid_frame, text="H6", variable=hybrid_A_6, onvalue=True, offvalue=False )
    hybrid_A_6_button.grid(row=1, column=8, padx=8)
    
    hybrid_A_QA = tk.BooleanVar()
    hybrid_A_QA_button = tk.Checkbutton( hybrid_frame, text="QA", variable=hybrid_A_QA, onvalue=True, offvalue=False )
    hybrid_A_QA_button.grid(row=1, column=9, padx=8)
    
    
    
    
    labelB = tk.Label(hybrid_frame, text='Array B: ', width = 8)
    labelB.grid(row=2, column=0)
    
    hybrid_B_0 = tk.BooleanVar()
    hybrid_B_0_button = tk.Checkbutton( hybrid_frame, text="H0", variable=hybrid_B_0, onvalue=True, offvalue=False )
    hybrid_B_0_button.grid(row=2, column=2, padx=8)
    
    hybrid_B_1 = tk.BooleanVar()
    hybrid_B_1_button = tk.Checkbutton( hybrid_frame, text="H1", variable=hybrid_B_1, onvalue=True, offvalue=False )
    hybrid_B_1_button.grid(row=2, column=3, padx=8)
    
    hybrid_B_2 = tk.BooleanVar()
    hybrid_B_2_button = tk.Checkbutton( hybrid_frame, text="H2", variable=hybrid_B_2, onvalue=True, offvalue=False )
    hybrid_B_2_button.grid(row=2, column=4, padx=8)
    
    hybrid_B_3 = tk.BooleanVar()
    hybrid_B_3_button = tk.Checkbutton( hybrid_frame, text="H3", variable=hybrid_B_3, onvalue=True, offvalue=False )
    hybrid_B_3_button.grid(row=2, column=5, padx=8)
    
    hybrid_B_4 = tk.BooleanVar()
    hybrid_B_4_button = tk.Checkbutton( hybrid_frame, text="H4", variable=hybrid_B_4, onvalue=True, offvalue=False )
    hybrid_B_4_button.grid(row=2, column=6, padx=8)
    
    hybrid_B_5 = tk.BooleanVar()
    hybrid_B_5_button = tk.Checkbutton( hybrid_frame, text="H5", variable=hybrid_B_5, onvalue=True, offvalue=False )
    hybrid_B_5_button.grid(row=2, column=7, padx=8)
    
    hybrid_B_6 = tk.BooleanVar()
    hybrid_B_6_button = tk.Checkbutton( hybrid_frame, text="H6", variable=hybrid_B_6, onvalue=True, offvalue=False )
    hybrid_B_6_button.grid(row=2, column=8, padx=8)
    
    hybrid_B_QA = tk.BooleanVar()
    hybrid_B_QA_button = tk.Checkbutton( hybrid_frame, text="QA", variable=hybrid_B_QA, onvalue=True, offvalue=False )
    hybrid_B_QA_button.grid(row=2, column=9, padx=8)
    

    
    
    labelC = tk.Label(hybrid_frame, text='Array C: ', width = 8)
    labelC.grid(row=3, column=0)
    
    hybrid_C_0 = tk.BooleanVar()
    hybrid_C_0_button = tk.Checkbutton( hybrid_frame, text="H0", variable=hybrid_C_0, onvalue=True, offvalue=False )
    hybrid_C_0_button.grid(row=3, column=2, padx=8)
    
    hybrid_C_1 = tk.BooleanVar()
    hybrid_C_1_button = tk.Checkbutton( hybrid_frame, text="H1", variable=hybrid_C_1, onvalue=True, offvalue=False )
    hybrid_C_1_button.grid(row=3, column=3, padx=8)
    
    hybrid_C_2 = tk.BooleanVar()
    hybrid_C_2_button = tk.Checkbutton( hybrid_frame, text="H2", variable=hybrid_C_2, onvalue=True, offvalue=False )
    hybrid_C_2_button.grid(row=3, column=4, padx=8)
    
    hybrid_C_3 = tk.BooleanVar()
    hybrid_C_3_button = tk.Checkbutton( hybrid_frame, text="H3", variable=hybrid_C_3, onvalue=True, offvalue=False )
    hybrid_C_3_button.grid(row=3, column=5, padx=8)
    
    hybrid_C_4 = tk.BooleanVar()
    hybrid_C_4_button = tk.Checkbutton( hybrid_frame, text="H4", variable=hybrid_C_4, onvalue=True, offvalue=False )
    hybrid_C_4_button.grid(row=3, column=6, padx=8)
    
    hybrid_C_5 = tk.BooleanVar()
    hybrid_C_5_button = tk.Checkbutton( hybrid_frame, text="H5", variable=hybrid_C_5, onvalue=True, offvalue=False )
    hybrid_C_5_button.grid(row=3, column=7, padx=8)
    
    hybrid_C_6 = tk.BooleanVar()
    hybrid_C_6_button = tk.Checkbutton( hybrid_frame, text="H6", variable=hybrid_C_6, onvalue=True, offvalue=False )
    hybrid_C_6_button.grid(row=3, column=8, padx=8)
    
    hybrid_C_QA = tk.BooleanVar()
    hybrid_C_QA_button = tk.Checkbutton( hybrid_frame, text="QA", variable=hybrid_C_QA, onvalue=True, offvalue=False )
    hybrid_C_QA_button.grid(row=3, column=9, padx=8)
    
    
    
    def create_panel():
        global db_password1, db_password2, client
        if not client:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        #if db_password1 and db_password2 :
        #    else:
        #box.showwarning( 'Warning', 'Please Get Passwords first.' )
        #Create Panel in DB
        
        panel_name = panel_name_entry.get().strip()
        batch_name = panel_name.rstrip('_0123456789')
        if batch_name.endswith('X'):
            type_name = 'X'
        elif batch_name.endswith('Y'):
            type_name = 'Y'
        else:
            box.showwarning( 'Warning', 'Wrong Format for Panel ID.' )
            return
    
        print( '========================================================')
        print('Panel Name: ', panel_name, '\tBatch Name: ', batch_name, '\tType: ', type_name)
        
 ###     ###safety feature: check that panel with this id does not exist
        
        
        create_panel = client.post('registerComponent', json={"project" : 'S',
                                      "subproject": 'SB',
                                      "institution": 'LIV',
                                      "componentType": 'HYBRID_FLEX_PANEL',
                                      "type": type_name,
                                      "properties":{
                                          "MANUFACTURER_ID": panel_name,
                                          "IMPEDANCE": float( panel_imp_entry.get() )
                                      },
                                      "batches":{
                                        "HYBRID_FLEXES_BATCH": batch_name  
                                      }
                                      })
        #print( json.dumps(create_panel, indent=3) )
        
        #test that panel was created
        panel = client.get('getComponent', json={"component":panel_name, "alternativeIdentifier":True})
        print( "Panel name: ", panel_name, "\tPanel ID: ", panel["code"] )
        
        print('Wait for 10 seconds for database to process registration')
        time.sleep(10)
        
        #print array names (only if not going to be deleted)
        db_array_A = client.get('getComponent', json={"component":panel_name +'_A', "alternativeIdentifier":True})
        if array_A.get()==False:
            print ('A: ', db_array_A["serialNumber"], '\t', db_array_A["alternativeIdentifier"])
        db_array_B = client.get('getComponent', json={"component":panel_name +'_B', "alternativeIdentifier":True})
        if array_B.get()==False:
            print ('B: ', db_array_B["serialNumber"], '\t', db_array_B["alternativeIdentifier"])
        db_array_C = client.get('getComponent', json={"component":panel_name +'_C', "alternativeIdentifier":True})
        if array_C.get()==False:
            print ('C: ', db_array_C["serialNumber"], '\t', db_array_C["alternativeIdentifier"])

            
        #disassemble arrays from panel
        disassemble_arrayA = client.post('disassembleComponent', json={ "parent": panel["code"],
                                                  "child": db_array_A["code"],
                                                  "trashed": False
                                                })

        disassemble_arrayB = client.post('disassembleComponent', json={ "parent": panel["code"],
                                                  "child": db_array_B["code"],
                                                  "trashed": False
                                                })

        disassemble_arrayC = client.post('disassembleComponent', json={ "parent": panel["code"],
                                                  "child": db_array_C["code"],
                                                  "trashed": False
                                                })
        print( f"Arrays disassembled: {db_array_A['serialNumber']}, {db_array_B['serialNumber']}, {db_array_C['serialNumber']}" )
        
        
        
        
        
        #delete chosen array
        if array_A.get()==True:
            client.post('deleteComponent', json={"component":db_array_A["code"]})
            print(f"{db_array_A['alternativeIdentifier']} deleted")
        if array_B.get()==True:
            client.post('deleteComponent', json={"component":db_array_B["code"]})
            print(f"{db_array_B['alternativeIdentifier']} deleted")
        if array_C.get()==True:
            client.post('deleteComponent', json={"component":db_array_C["code"]})
            print(f"{db_array_C['alternativeIdentifier']} deleted")
        
        
        #move selected hybrid to new stage


        def set_hybrid_stage_failed(client, component_ID):
            comp = client.get('getComponent', json={"component" : component_ID, "alternativeIdentifier" : True})
            print(f"Setting stage {'FAILED'} for hybrid {component_ID} ...")
            stage_transition = client.post("setComponentStage", json={'component' : comp["code"] , 'stage' : 'FAILED'})

        
        if array_A.get()==False and hybrid_A_0.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_H0' )
            print(f"{panel_name+'_A'+'_H0'} is a crossed-out circuit.")
        if array_A.get()==False and hybrid_A_1.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_H1' )
            print(f"{panel_name+'_A'+'_H1'} is a crossed-out circuit.")
        if array_A.get()==False and hybrid_A_2.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_H2' )
            print(f"{panel_name+'_A'+'_H2'} is a crossed-out circuit.")
        if array_A.get()==False and hybrid_A_3.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_H3' )
            print(f"{panel_name+'_A'+'_H3'} is a crossed-out circuit.")
        if array_A.get()==False and hybrid_A_4.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_H4' )
            print(f"{panel_name+'_A'+'_H4'} is a crossed-out circuit.")
        if array_A.get()==False and hybrid_A_5.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_H5' )
            print(f"{panel_name+'_A'+'_H5'} is a crossed-out circuit.")
        if array_A.get()==False and hybrid_A_6.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_H6' )
            print(f"{panel_name+'_A'+'_H6'} is a crossed-out circuit.")
        if array_A.get()==False and hybrid_A_QA.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_A'+'_QA' )
            print(f"{panel_name+'_A'+'_QA'} is a crossed-out circuit.")
        
        if array_B.get()==False and hybrid_B_0.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_H0' )
            print(f"{panel_name+'_B'+'_H0'} is a crossed-out circuit.")
        if array_B.get()==False and hybrid_B_1.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_H1' )
            print(f"{panel_name+'_B'+'_H1'} is a crossed-out circuit.")
        if array_B.get()==False and hybrid_B_2.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_H2' )
            print(f"{panel_name+'_B'+'_H2'} is a crossed-out circuit.")
        if array_B.get()==False and hybrid_B_3.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_H3' )
            print(f"{panel_name+'_B'+'_H3'} is a crossed-out circuit.")
        if array_B.get()==False and hybrid_B_4.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_H4' )
            print(f"{panel_name+'_B'+'_H4'} is a crossed-out circuit.")
        if array_B.get()==False and hybrid_B_5.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_H5' )
            print(f"{panel_name+'_B'+'_H5'} is a crossed-out circuit.")
        if array_B.get()==False and hybrid_B_6.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_H6' )
            print(f"{panel_name+'_B'+'_H6'} is a crossed-out circuit.")
        if array_B.get()==False and hybrid_B_QA.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_B'+'_QA' )
            print(f"{panel_name+'_B'+'_QA'} is a crossed-out circuit.")
        
        if array_C.get()==False and hybrid_C_0.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_H0' )
            print(f"{panel_name+'_C'+'_H0'} is a crossed-out circuit.")
        if array_C.get()==False and hybrid_C_1.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_H1' )
            print(f"{panel_name+'_C'+'_H1'} is a crossed-out circuit.")
        if array_C.get()==False and hybrid_C_2.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_H2' )
            print(f"{panel_name+'_C'+'_H2'} is a crossed-out circuit.")
        if array_C.get()==False and hybrid_C_3.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_H3' )
            print(f"{panel_name+'_C'+'_H3'} is a crossed-out circuit.")
        if array_C.get()==False and hybrid_C_4.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_H4' )
            print(f"{panel_name+'_C'+'_H4'} is a crossed-out circuit.")
        if array_C.get()==False and hybrid_C_5.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_H5' )
            print(f"{panel_name+'_C'+'_H5'} is a crossed-out circuit.")
        if array_C.get()==False and hybrid_C_6.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_H6' )
            print(f"{panel_name+'_C'+'_H6'} is a crossed-out circuit.")
        if array_C.get()==False and hybrid_C_QA.get()==True:
            set_hybrid_stage_failed( client, panel_name+'_C'+'_QA' )
            print(f"{panel_name+'_C'+'_QA'} is a crossed-out circuit.")
        
        
        
        #disassemble test coupon
        if array_A.get()==False:
            testCoupon_A = client.get('getComponent', json={"component":panel_name +'_A' + '_QA', "alternativeIdentifier":True})
            disassemble_tcA = client.post('disassembleComponent', json={ "parent": db_array_A["code"],
                                                  "child": testCoupon_A["code"],
                                                  "trashed": False
                                                    })
            print(f"{testCoupon_A['alternativeIdentifier']} disassembled from array")
        if array_B.get()==False:
            testCoupon_B = client.get('getComponent', json={"component":panel_name +'_B' + '_QA', "alternativeIdentifier":True})
            disassemble_tcB = client.post('disassembleComponent', json={ "parent": db_array_B["code"],
                                                  "child": testCoupon_B["code"],
                                                  "trashed": False
                                                    })
            print(f"{testCoupon_B['alternativeIdentifier']} disassembled from array")
        if array_C.get()==False:
            testCoupon_C = client.get('getComponent', json={"component":panel_name +'_C' + '_QA', "alternativeIdentifier":True})
            disassemble_tcC = client.post('disassembleComponent', json={ "parent": db_array_C["code"],
                                                  "child": testCoupon_C["code"],
                                                  "trashed": False
                                                    })
            print(f"{testCoupon_C['alternativeIdentifier']} disassembled from array")
        
        
        

        #Reset all Tick-Boxes
        array_A_button.deselect()
        array_B_button.deselect()
        array_C_button.deselect()
        
        hybrid_A_0_button.deselect()
        hybrid_A_1_button.deselect()
        hybrid_A_2_button.deselect()
        hybrid_A_3_button.deselect()
        hybrid_A_4_button.deselect()
        hybrid_A_5_button.deselect()
        hybrid_A_6_button.deselect()
        hybrid_A_QA_button.deselect()
        
        hybrid_B_0_button.deselect()
        hybrid_B_1_button.deselect()
        hybrid_B_2_button.deselect()
        hybrid_B_3_button.deselect()
        hybrid_B_4_button.deselect()
        hybrid_B_5_button.deselect()
        hybrid_B_6_button.deselect()
        hybrid_B_QA_button.deselect()
        
        hybrid_C_0_button.deselect()
        hybrid_C_1_button.deselect()
        hybrid_C_2_button.deselect()
        hybrid_C_3_button.deselect()
        hybrid_C_4_button.deselect()
        hybrid_C_5_button.deselect()
        hybrid_C_6_button.deselect()
        hybrid_C_QA_button.deselect()
        
        panel_imp_entry.delete(0,'end')
        
        box.showinfo( 'Info', f"Hybrid flex manufacturer panel ({panel_name_entry.get()}), arrays and hybrid flexes created." )

        

    create_button = tk.Button(app, text='Create', width = 20, command = create_panel )
    create_button.pack(  padx = 10, pady = 10)  
        
        
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed    
    
    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
        
        
    app.mainloop()

    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    flex_panel_registration_interface()
   


# In[ ]:




