#!/usr/bin/env python
# coding: utf-8

# In[2]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from PIL import ImageTk, Image

import pull_test_interface as pull_interface

import database_interface as db_interface

import visual_inspection_interface as vi_interface

import flex_panel_registration_interface as flex_reg_interface

import hybrid_assembly_interface_V0 as hybrid_assembly_interface


def gui_interface():

    #global variables from function access
    
    

    app = tk.Tk()
    app.title('User Interface')

    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()



    #Liverpool logo
    image = Image.open('Liv-Logo.jpg')
    image_width, image_height = image.size 
    #print(width, '\t', height)
    image_scalefactor = 0.25
    image = image.resize( ( int(image_scalefactor*image_width), int(image_scalefactor*image_height) ), Image.ANTIALIAS)
    my_img = ImageTk.PhotoImage(image)
    my_imgd = tk.Label( image = my_img )
    my_imgd.pack()
    
    
    

    label0 = tk.Label(app, text='Liverpool ATLAS Upgrade Interface', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label0.pack(padx = 10, pady = 10)

    
    
    labe00 = tk.Label(app, text='Flex Registration')
    labe00.pack(padx = 10, pady = 10)
    
    reg_button = tk.Button(app, text='Hybrid Flex Registration', width = 20,                            command = flex_reg_interface.flex_panel_registration_interface )
    reg_button.pack( padx = 10, pady = 10)
    
    
    labe01 = tk.Label(app, text='Database json upload and stage transition')
    labe01.pack(padx = 10, pady = 10)
    
    db_button = tk.Button(app, text='Database Interface', width = 20, command = db_interface.db_interface )
    db_button.pack( padx = 10, pady = 10)
    

    labe02 = tk.Label(app, text='Pull Test Analysis and json creation')
    labe02.pack(padx = 10, pady = 10)
    
    pull_button = tk.Button(app, text='Pull Test Analysis', width = 20, command = pull_interface.pull_popup )
    pull_button.pack( padx = 10, pady = 10)


    
    labe021 = tk.Label(app, text='Visual Inspection')
    labe021.pack(padx = 10, pady = 10)
    
    vi_button = tk.Button(app, text='Visual Inspection', width = 20, command = vi_interface.visualinspection_popup )
    vi_button.pack( padx = 10, pady = 10)
    
    
    labe03 = tk.Label(app, text='Metrology')
    labe03.pack(padx = 10, pady = 10)
    
    
    labe04 = tk.Label(app, text='Flex QC -> change Labview as well')
    labe04.pack(padx = 10, pady = 10)
    
    
    labe05 = tk.Label(app, text='Wire Bond (hybrid or module)')
    labe05.pack(padx = 10, pady = 10)
    
    
    labe06 = tk.Label(app, text='DB Shipping')
    labe06.pack(padx = 10, pady = 10)
    
    
    labe07 = tk.Label(app, text='Hybrid Assembly')
    labe07.pack(padx = 10, pady = 10)
    
    hybrid_asm_button = tk.Button(app, text='Hybrid Assembly', width = 20, command = hybrid_assembly_interface.hybrid_assembly_interface )
    hybrid_asm_button.pack( padx = 10, pady = 10)
    
    
    
    


    exit_button = tk.Button(app, text='Close All', width=25, command=app.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)

    app.mainloop()

    
    
if __name__ == "__main__":
    gui_interface()


# In[ ]:




